Index: /trunk/src/sh_utmp.c
===================================================================
--- /trunk/src/sh_utmp.c	(revision 584)
+++ /trunk/src/sh_utmp.c	(revision 1)
@@ -79,8 +79,5 @@
 #include "sh_modules.h"
 #include "sh_utmp.h"
-#include "sh_pthread.h"
-#include "sh_inotify.h"
-
-SH_MUTEX_EXTERN(mutex_thread_nolog);
+
 
 #ifdef TM_IN_SYS_TIME
@@ -141,42 +138,57 @@
 #ifdef HAVE_UTMPX_H
 
-#if defined(_PATH_UTMPX)
-#define SH_PATH_UTMP _PATH_UTMPX
-#elif defined(UTMPX_FILE)
-#define SH_PATH_UTMP UTMPX_FILE
-#elif defined(_PATH_UTMP)
-#define SH_PATH_UTMP _PATH_UTMP
-#else
+#ifndef _PATH_UTMP
+#ifdef   UTMPX_FILE
+#define _PATH_UTMP   UTMPX_FILE
+#else  
 #error  You must define UTMPX_FILE in the file config.h 
 #endif
-
-#else
-
-#if defined(_PATH_UTMP)
-#define SH_PATH_UTMP _PATH_UTMP
-#elif defined(UTMP_FILE)
-#define SH_PATH_UTMP UTMP_FILE
+#endif
+#ifndef _PATH_WTMP
+#ifdef   WTMPX_FILE
+#define _PATH_WTMP   WTMPX_FILE
+#else
+#error  You must define WTMPX_FILE in the file config.h
+#endif
+#endif
+
+#else
+
+#ifndef _PATH_UTMP
+#ifdef   UTMP_FILE
+#define _PATH_UTMP   UTMP_FILE
 #else  
 #error  You must define UTMP_FILE in the file config.h 
 #endif
+#endif
+#ifndef _PATH_WTMP
+#ifdef   WTMP_FILE
+#define _PATH_WTMP   WTMP_FILE
+#else
+#error  You must define WTMP_FILE in the file config.h
+#endif
+#endif
 
 #endif
 
 typedef struct log_user {
-  time_t              last_checked;
   char                ut_tty[UT_LINESIZE+1];    
   char                name[UT_NAMESIZE+1];
   char                ut_host[UT_HOSTSIZE+1];
-  char                ut_ship[SH_IP_BUF]; /* IP address */
+  char                ut_ship[16]; /* IP address */
   time_t              time;
   struct log_user   * next;
 } blah_utmp;
 
-static char * utmp_path = SH_PATH_UTMP;
+#ifdef HAVE_UTTYPE
+static char   terminated_line[UT_HOSTSIZE]; 
+#endif
+
+static struct SH_UTMP_S save_utmp;
 
 static void sh_utmp_logout_morechecks(struct log_user   * user);
 static void sh_utmp_login_morechecks(struct SH_UTMP_S * ut);
-static void sh_utmp_checklogin (struct SH_UTMP_S * ut, time_t start_read);
-static void sh_utmp_check_internal();
+static void sh_utmp_addlogin (struct SH_UTMP_S * ut);
+static void sh_utmp_check_internal(int mode);
 
 static int    ShUtmpLoginSolo    = SH_ERR_INFO;
@@ -208,20 +220,4 @@
   },
   {
-    N_("logincheckfirst"),
-    sh_login_set_checklevel
-  },
-  {
-    N_("logincheckoutlier"),
-    sh_login_set_siglevel
-  },
-  {
-    N_("logincheckdate"),
-    sh_login_set_def_allow
-  },
-  {
-    N_("logincheckuserdate"),
-    sh_login_set_user_allow
-  },
-  {
     NULL,
     NULL
@@ -229,28 +225,17 @@
 };
 
-static void set_defaults(void)
-{
-  ShUtmpLoginSolo    = SH_ERR_INFO;
-  ShUtmpLoginMulti   = SH_ERR_WARN;
-  ShUtmpLogout       = SH_ERR_INFO;
-  ShUtmpActive       = S_TRUE;
-  ShUtmpInterval     = 300;
-
-  sh_login_reset();
-  return;
-}
-
-#if defined(HAVE_UTMPX_H) && defined(HAVE_GETUTXENT)
-#define USE_SETUTENT 1
-#elif defined(HAVE_GETUTENT)
-#define USE_SETUTENT 1
-#endif
-
-
-#if defined (USE_SETUTENT)
-
-#ifdef HAVE_UTMPX_H 
-
-#define sh_utmp_utmpname(a)  (void)(a)
+int sh_utmp_null()
+{
+  return 0;
+}
+
+
+
+
+#if defined (HAVE_SETUTENT) && defined (USE_SETUTENT)
+
+#ifdef HAVE_UTMPX_H
+
+#define sh_utmp_utmpname     utmpxname
 #define sh_utmp_setutent     setutxent
 #define sh_utmp_endutent     endutxent
@@ -281,6 +266,10 @@
 
 static FILE * sh_utmpfile = NULL;
-static char   sh_utmppath[80] = SH_PATH_UTMP;
-
+static char   sh_utmppath[80] = _PATH_UTMP;
+
+/* sh_utmp_feed_forward is for optimizing
+ * (fseek instead of getutent loop)
+ */
+static long   sh_utmp_feed_forward = 0;
 
 static void sh_utmp_utmpname(const char * str)
@@ -289,9 +278,9 @@
   if (sh_utmpfile != NULL)
     {
-      (void) sl_fclose (FIL__, __LINE__, sh_utmpfile);
+      (void) fclose (sh_utmpfile);
       sh_utmpfile = NULL;
     }
 
-  (void) sl_strlcpy (sh_utmppath, str, sizeof(sh_utmppath));
+  (void) sl_strlcpy (sh_utmppath, str, 80);
   SL_RET0(_("sh_utmp_utmpname"));
 }
@@ -304,10 +293,13 @@
   SL_ENTER(_("sh_utmp_setutent"));
 
+  ASSERT((sh_utmppath != NULL), _("sh_utmppath != NULL"));
+
+  if (sh_utmppath == NULL)
+    SL_RET0(_("sh_utmp_setutent"));
+
   if (sh_utmpfile == NULL) 
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       fd = (int) aud_open (FIL__, __LINE__, SL_NOPRIV, 
 			   sh_utmppath, O_RDONLY, 0);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
       if (fd >= 0)
 	{
@@ -321,12 +313,15 @@
 	{
 	  error = errno;
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle ((-1), FIL__, __LINE__, error, MSG_E_ACCESS,
 			   (long) sh.real.uid, sh_utmppath);
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
 	  SL_RET0(_("sh_utmp_setutent"));
 	}
     }
   (void) fseek (sh_utmpfile, 0L, SEEK_SET);
+  if (-1 == fseek (sh_utmpfile, sh_utmp_feed_forward, SEEK_CUR))
+    {
+      sh_utmp_feed_forward = 0; /* modified Apr 4, 2004 */
+      (void) fseek (sh_utmpfile, 0L, SEEK_SET);
+    }
   clearerr (sh_utmpfile);
   SL_RET0(_("sh_utmp_setutent"));
@@ -336,6 +331,5 @@
 {
   SL_ENTER(_("sh_utmp_endutent"));
-  if (NULL != sh_utmpfile)
-    (void) sl_fclose(FIL__, __LINE__, sh_utmpfile);
+  (void) fclose(sh_utmpfile);
   sh_utmpfile = NULL;
   SL_RET0(_("sh_utmp_endutent"));
@@ -368,36 +362,84 @@
 }
 
+#ifdef USE_UNUSED
+
+static struct SH_UTMP_S * sh_utmp_getutline(struct SH_UTMP_S * ut)
+{
+  struct SH_UTMP_S * out;
+ 
+  while (1) {
+      if ((out = sh_utmp_getutent()) == NULL) {
+       	return NULL;
+      }
+#ifdef HAVE_UTTYPE  
+      if (out->ut_type == USER_PROCESS || out->ut_type == LOGIN_PROCESS)
+	if (sl_strcmp(ut->ut_line, out->ut_line) == 0) 
+	  return out;
+#else
+      if ( 0 != sl_strncmp (out->ut_name, "reboot",   6) &&
+	   0 != sl_strncmp (out->ut_name, "shutdown", 8) &&
+	   0 != sl_strncmp (out->ut_name, "date",     4) )
+	return out;
+#endif
+  }
+  return NULL;
+}
+
+static struct SH_UTMP_S * sh_utmp_getutid(struct SH_UTMP_S * ut)
+{
+#ifdef HAVE_UTTYPE  
+  struct SH_UTMP_S * out;
+
+  if (ut->ut_type == RUN_LVL  || ut->ut_type == BOOT_TIME ||
+      ut->ut_type == NEW_TIME || ut->ut_type == OLD_TIME) 
+    {
+      while (1) {
+	if ((out = sh_utmp_getutent()) == NULL) {
+	  return NULL;
+	}
+	if (out->ut_type == ut->ut_type) 
+	  return out;
+      }
+    } 
+  else if (ut->ut_type == INIT_PROCESS || ut->ut_type == LOGIN_PROCESS ||
+	   ut->ut_type == USER_PROCESS || ut->ut_type == DEAD_PROCESS ) 
+    {
+      while (1) {
+	if ((out = sh_utmp_getutent()) == NULL) {
+	  return NULL;
+	}
+	if (sl_strcmp(ut->ut_id, out->ut_id) == 0) 
+	  return out;
+      }
+    }
+#endif
+  return NULL;
+}
+/* #ifdef USE_UNUSED */
+#endif
+
 /* #ifdef HAVE_SETUTENT */
 #endif
 
 #ifdef HAVE_UTADDR
-#ifdef HAVE_UTADDR_V6
-static char * my_inet_ntoa(SINT32 * ut_addr_v6, char * buf, size_t buflen)
-{
-  struct in_addr in;
-
-  buf[0] = '\0';
-
-  if (0 == (ut_addr_v6[1] + ut_addr_v6[2] + ut_addr_v6[3]))
-    {
-      memcpy(&in, ut_addr_v6, sizeof(struct in_addr));
-      sl_strlcpy(buf, inet_ntoa(in), buflen);
-    }
-  else
-    {
-      inet_ntop(AF_INET6, ut_addr_v6, buf, buflen);
-    }
-  return buf;
-}
-#else
-static char * my_inet_ntoa(SINT32 ut_addr, char * buf, size_t buflen)
-{
-  struct in_addr in;
-
-  buf[0] = '\0';
-
-  memcpy(&in, ut_addr, sizeof(struct in_addr));
-  sl_strlcpy(buf, inet_ntoa(in), buflen);
-  return buf;
+#ifdef HAVE_INET_ATON
+static char * my_inet_ntoa(struct in_addr in)
+{
+  return /*@-unrecog@*/inet_ntoa(in)/*@+unrecog@*/;
+}
+#else
+static char * my_inet_ntoa(struct in_addr in)
+{
+  unsigned char a, b, c, d;
+  static char   foo[16];
+  char          bar[4];
+  memcpy (bar, &(in.s_addr), 4); /* memory alignment (?) */
+  memcpy (&a, &bar[0], 1);
+  memcpy (&b, &bar[1], 1);
+  memcpy (&c, &bar[2], 1);
+  memcpy (&d, &bar[3], 1);
+  sprintf(foo, "%d.%d.%d.%d",                          /* known to fit  */
+	  (int) a, (int) b, (int) c, (int) d);
+  return foo;
 }
 #endif
@@ -412,5 +454,4 @@
 static struct log_user   * userlist   = NULL;
 static time_t  lastcheck;
-static int     init_done = 0;
 
 /*************
@@ -419,7 +460,7 @@
  *
  *************/
-
-static int sh_utmp_init_internal (void)
-{
+int sh_utmp_init ()
+{
+  static int done = 0;
 
   SL_ENTER(_("sh_utmp_init"));
@@ -429,37 +470,14 @@
   /* do not re-initialize after a re-configuration
    */
-  if (init_done == 1) {
+  if (done == 1) {
     SL_RETURN( (0), _("sh_utmp_init"));
   }
   lastcheck  = time (NULL);
   userlist   = NULL;
-  sh_utmp_check_internal (); /* current logins */
-  init_done = 1;
+  memset (&save_utmp, 0, sizeof(struct SH_UTMP_S));
+  sh_utmp_check_internal (2); /* current logins */
+  sh_utmp_check_internal (0);
+  done = 1;
   SL_RETURN( (0), _("sh_utmp_init"));
-}
-
-int sh_utmp_init (struct mod_type * arg)
-{
-#if !defined(HAVE_PTHREAD)
-  (void) arg;
-#endif
-  if (ShUtmpActive == BAD)
-    return SH_MOD_FAILED;
-#ifdef HAVE_PTHREAD
-  if (arg != NULL && arg->initval < 0 && 
-      (sh.flag.isdaemon == S_TRUE || sh.flag.loop == S_TRUE))
-    {
-      if (0 == sh_pthread_create(sh_threaded_module_run, (void *)arg))
-	return SH_MOD_THREAD;
-      else
-	return SH_MOD_FAILED;
-    }
-  else if (arg != NULL && arg->initval == SH_MOD_THREAD &&
-	   (sh.flag.isdaemon == S_TRUE || sh.flag.loop == S_TRUE))
-    {
-      return SH_MOD_THREAD;
-    }
-#endif
-  return sh_utmp_init_internal();
 }
 
@@ -470,9 +488,5 @@
  *************/
 #ifdef HAVE_UTTYPE
-static int sh_utmp_login_clean(void);
-#endif
-
-#if defined(HAVE_PTHREAD)
-static sh_watches inotify_watch = SH_INOTIFY_INITIALIZER;
+static int sh_utmp_login_clean();
 #endif
 
@@ -493,25 +507,5 @@
   (void) sh_utmp_login_clean();
 #endif
-  /* Reset the flag, such that the module
-   * can be re-enabled.
-   */
-  set_defaults();
-  init_done          = 0;
-
-#if defined(HAVE_PTHREAD)
-  sh_inotify_remove(&inotify_watch);
-#endif
-
   SL_RETURN( (0), _("sh_utmp_end"));
-}
-
-
-int sh_utmp_reconf()
-{
-  set_defaults();
-#if defined(HAVE_PTHREAD)
-  sh_inotify_remove(&inotify_watch);
-#endif
-  return 0;
 }
 
@@ -524,7 +518,4 @@
 int sh_utmp_timer (time_t tcurrent)
 {
-#if !defined(HAVE_PTHREAD)
-  retry_msleep(1, 0);
-
   if ((time_t) (tcurrent - lastcheck) >= ShUtmpInterval)
     {
@@ -533,29 +524,4 @@
     }
   return 0;
-#else
-  int errnum = 0;
-  
-  if ( (sh.flag.isdaemon == S_TRUE || sh.flag.loop == S_TRUE) &&
-       sh.flag.checkSum != SH_CHECK_INIT )
-    {
-      sh_inotify_wait_for_change(utmp_path, &inotify_watch, 
-				 &errnum, ShUtmpInterval);
-    }
-  
-  lastcheck  = tcurrent;
-
-  if (SH_INOTIFY_ERROR(errnum))
-    {
-      char ebuf[SH_ERRBUF_SIZE];
-
-      SH_MUTEX_LOCK(mutex_thread_nolog);
-      sh_error_message(errnum, ebuf, sizeof(ebuf));
-      sh_error_handle (SH_ERR_WARN, FIL__, __LINE__, errnum, MSG_E_SUBGEN,
-		       ebuf,
-		       _("sh_utmp_timer") );
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);    
-    }
-  return -1;
-#endif
 }
 
@@ -568,15 +534,6 @@
 {
   SL_ENTER(_("sh_utmp_check"));
-  if (ShUtmpActive == BAD)
-    {
-#if defined(HAVE_PTHREAD)
-      sh_inotify_remove(&inotify_watch);
-#endif
-      SL_RETURN( (-1), _("sh_utmp_check"));
-    }
-  SH_MUTEX_LOCK(mutex_thread_nolog);
   sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_UT_CHECK);
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-  sh_utmp_check_internal ();
+  sh_utmp_check_internal (1);
 
   SL_RETURN(0, _("sh_utmp_check"));
@@ -589,5 +546,5 @@
  *************/
 
-int sh_utmp_set_login_solo  (const char * c)
+int sh_utmp_set_login_solo  (char * c)
 {
   int retval;
@@ -597,11 +554,9 @@
   tmp[0] = '='; tmp[1] = '\0';
   (void) sl_strlcat (tmp, c, 32);
-  SH_MUTEX_LOCK(mutex_thread_nolog);
   retval = sh_error_set_level (tmp, &ShUtmpLoginSolo);
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
   SL_RETURN(retval, _("sh_utmp_set_login_solo"));
 }
 
-int sh_utmp_set_login_multi (const char * c)
+int sh_utmp_set_login_multi (char * c)
 {
   int retval;
@@ -611,11 +566,9 @@
   tmp[0] = '='; tmp[1] = '\0';
   (void) sl_strlcat (tmp, c, 32);
-  SH_MUTEX_LOCK(mutex_thread_nolog);
   retval = sh_error_set_level (tmp, &ShUtmpLoginMulti);
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
   SL_RETURN(retval, _("sh_utmp_set_login_multi"));
 }
 
-int sh_utmp_set_logout_good (const char * c)
+int sh_utmp_set_logout_good (char * c)
 {
   int retval;
@@ -625,12 +578,11 @@
   tmp[0] = '='; tmp[1] = '\0';
   (void) sl_strlcat (tmp, c, 32);
-  SH_MUTEX_LOCK(mutex_thread_nolog);
   retval = sh_error_set_level (tmp, &ShUtmpLogout);
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
   SL_RETURN(retval, _("sh_utmp_set_logout_good"));
 }
 
-int sh_utmp_set_login_timer (const char * c)
-{
+int sh_utmp_set_login_timer (char * c)
+{
+  int retval = 0;
   long val;
 
@@ -639,10 +591,10 @@
   if (val <= 0)
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, EINVAL, MSG_EINVALS,
 		       _("utmp timer"), c);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-      SL_RETURN((-1), _("sh_utmp_set_login_timer"));
-    }
+      retval = -1;
+    }
+
+  val = (val <= 0 ? 60 : val);
 
   ShUtmpInterval = (time_t) val;
@@ -650,5 +602,5 @@
 }
 
-int sh_utmp_set_login_activate (const char * c)
+int sh_utmp_set_login_activate (char * c)
 {
   int i;
@@ -658,5 +610,5 @@
 }
 
-
+#ifdef HAVE_UTTYPE
 struct login_ct {
   char name[UT_NAMESIZE+1];
@@ -667,5 +619,5 @@
 static struct login_ct * login_ct_list = NULL;
 
-static int sh_utmp_login_clean(void)
+static int sh_utmp_login_clean()
 {
   struct login_ct * list = login_ct_list;
@@ -738,4 +690,5 @@
 }
 
+#endif
 
 
@@ -745,282 +698,297 @@
  *    - link user.ut_record   -> log_record
  */
-
-#include <ctype.h>
+#ifdef HAVE_UTTYPE  
 static int sh_utmp_is_virtual (char * in_utline, char * in_uthost)
 {
-
-  if (in_uthost != NULL   &&
-      in_utline != NULL   &&
+  if (in_utline != NULL)
+    {
+      if (0 == sl_strncmp(in_utline, _("ttyp"), 4))
+	{ return 0; }
+      else if (0 == sl_strncmp(in_utline, _("ttyq"), 4))
+	{ return 0; }
+    }
+  if (in_uthost != NULL   && 
       in_uthost[0] == ':' && 
-      isdigit((int) in_uthost[1]) && 
-      0 == sl_strncmp(in_utline, _("pts/"), 4))
-    {
-      return 1;
-    }
-
-  return 0;
-}
-
-
-static void sh_utmp_log_out(int sev, struct log_user * user, int n)
-{
-  char ttt[TIM_MAX];
-  
-  SH_MUTEX_LOCK(mutex_thread_nolog);
-  (void) sh_unix_time (user->time, ttt, TIM_MAX);
-  sh_error_handle( sev, FIL__, __LINE__, 0,
-#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
-		   MSG_UT_LG3X,
-#elif defined(HAVE_UTHOST)
-		   MSG_UT_LG3A,
-#else
-		   MSG_UT_LG3B,
-#endif
-		   user->name,
-		   user->ut_tty,
-#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
-		   user->ut_host,
-		   user->ut_ship,
-#elif defined(HAVE_UTHOST)
-		   user->ut_host,
-#endif
-		   ttt,
-		   n
-		   );
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-}
-
-static void sh_utmp_log_multi(int sev, struct log_user * user, int n)
-{
-  char ttt[TIM_MAX];
-  
-  SH_MUTEX_LOCK(mutex_thread_nolog);
-  (void) sh_unix_time (user->time, ttt, TIM_MAX);
-  sh_error_handle( sev, FIL__, __LINE__, 0,
-#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
-		   MSG_UT_LG2X,
-#elif defined(HAVE_UTHOST)
-		   MSG_UT_LG2A,
-#else
-		   MSG_UT_LG2B,
-#endif
-		   user->name,
-		   user->ut_tty,
-#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
-		   user->ut_host,
-		   user->ut_ship,
-#elif defined(HAVE_UTHOST)
-		   user->ut_host,
-#endif
-		   ttt,
-		   n
-		   );
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-}
-
-static void sh_utmp_log_one(int sev, struct log_user * user, int n)
-{
-  char ttt[TIM_MAX];
-  
-  SH_MUTEX_LOCK(mutex_thread_nolog);
-  (void) sh_unix_time (user->time, ttt, TIM_MAX);
-  sh_error_handle( sev, FIL__, __LINE__, 0,
-#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
-		   MSG_UT_LG1X,
-#elif defined(HAVE_UTHOST)
-		   MSG_UT_LG1A,
-#else
-		   MSG_UT_LG1B,
-#endif
-		   user->name,
-		   user->ut_tty,
-#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
-		   user->ut_host,
-		   user->ut_ship,
-#elif defined(HAVE_UTHOST)
-		   user->ut_host,
-#endif
-		   ttt,
-		   n
-		   );
-  SH_MUTEX_UNLOCK(mutex_thread_nolog);
-}
-
-static void sh_utmp_purge_old (time_t start_read)
+      in_uthost[1] == '0' && 
+      in_uthost[2] == '\0')
+    {
+      /* return 0; */
+      return 1;  /* actually does not seem portable, not even among linuxes */
+    }
+  return 1;
+}
+#endif
+
+static void sh_utmp_addlogin (struct SH_UTMP_S * ut)
 {
   struct log_user   * user     = userlist;
   struct log_user   * userold  = userlist;
-  volatile int        status;
-
-  /* ------- find old entries -------- 
+#ifdef HAVE_UTTYPE  
+  struct log_user   * username = userlist;
+#endif
+
+  char   ttt[TIM_MAX];
+#ifdef HAVE_UTTYPE
+  int    status;
+#endif
+
+  SL_ENTER(_("sh_utmp_addlogin"));
+
+  if (ut->ut_line[0] == '\0')
+    SL_RET0(_("sh_utmp_addlogin"));
+
+  /* for some stupid reason, AIX repeats the wtmp entry for logouts
+   * with ssh
+   */
+  if (memcmp (&save_utmp, ut, sizeof(struct SH_UTMP_S)) == 0)
+    {
+      memset(&save_utmp, (int) '\0', sizeof(struct SH_UTMP_S));
+      SL_RET0(_("sh_utmp_addlogin"));
+    }
+  memcpy (&save_utmp, ut, sizeof(struct SH_UTMP_S));
+
+
+  /* ------- find user -------- 
    */
   while (user != NULL) 
     {
-      if (user->last_checked < start_read)
+      if (0 == sl_strncmp(user->ut_tty, ut->ut_line, UT_LINESIZE) ) 
+	break;
+      userold = user;
+      user = user->next;
+    }
+
+#ifdef HAVE_UTTYPE  
+  while (username != NULL) 
+    {
+      if (0 == sl_strncmp(username->name, ut->ut_name, UT_NAMESIZE) ) 
+	break;
+      username = username->next;
+    }
+#endif
+  
+#ifdef HAVE_UTTYPE  
+  /* ---------- LOGIN -------------- */
+  if (ut->ut_type == USER_PROCESS) 
+    {
+      if (user == NULL)
 	{
-	  /* report logout */
-	  if (0 == sh_utmp_is_virtual(user->ut_tty, user->ut_host))
-	    {
-	      /* reference count down on list of logged in users */
-	      status = sh_utmp_login_r(user->name);
-	      
-	      sh_utmp_log_out(ShUtmpLogout, user, status);
-	      sh_utmp_logout_morechecks((struct log_user *)user);
-	    }
-
-	  /* remove entry */
-	  if (userold == user && userold == userlist)
-	    {
-	      /* first element in userlist, advance userlist & userold */
-	      userold  = user->next;
-	      userlist = user->next;
-	      SH_FREE((struct log_user *)user);
-	      user     = userlist;
-	    }
-	  else
-	    {
-	      /* other element in userlist, cut it out */
-	      userold->next = user->next;
-	      SH_FREE((struct log_user *)user);
-	      user = userold->next;
-	    }
+	  user = SH_ALLOC(sizeof(struct log_user));
+	  user->next       = userlist;
+	  userlist         = user;
+	}
+      (void) sl_strlcpy(user->ut_tty,  ut->ut_line, UT_LINESIZE+1);
+      (void) sl_strlcpy(user->name,    ut->ut_name, UT_NAMESIZE+1);
+#ifdef HAVE_UTHOST
+      (void) sl_strlcpy(user->ut_host, ut->ut_host, UT_HOSTSIZE+1);
+#else
+      user->ut_host[0] = '\0';
+#endif
+#ifdef HAVE_UTADDR
+      /*@-type@*//* ut_addr does exist !!! */
+      (void) sl_strlcpy(user->ut_ship, 
+			my_inet_ntoa(*(struct in_addr*)&(ut->ut_addr)), 16);
+      /*@+type@*/
+#endif
+      user->time = ut->ut_time;
+
+      if (username == NULL                              /* not yet logged in */
+          || 0 == sl_strncmp(ut->ut_line, _("ttyp"), 4) /* in virt. console  */
+          || 0 == sl_strncmp(ut->ut_line, _("ttyq"), 4) /* in virt. console  */
+	  ) {
+	status = sh_utmp_login_a(user->name);
+	(void) sl_strlcpy(ttt, sh_unix_time (user->time), TIM_MAX);
+	sh_error_handle( ShUtmpLoginSolo, FIL__, __LINE__, 0,
+#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
+			 MSG_UT_LG1X,
+#elif defined(HAVE_UTHOST)
+			 MSG_UT_LG1A,
+#else
+			 MSG_UT_LG1B,
+#endif
+			 user->name,
+			 user->ut_tty,
+#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
+			 user->ut_host,
+			 user->ut_ship,
+#elif defined(HAVE_UTHOST)
+			 user->ut_host,
+#endif
+			 ttt,
+			 status
+			 );
+      } else
+	if (0 != sh_utmp_is_virtual(ut->ut_line, user->ut_host))
+	  {       
+	    status = sh_utmp_login_a(user->name);
+	    (void) sl_strlcpy(ttt, sh_unix_time (user->time), TIM_MAX);
+	    sh_error_handle( ShUtmpLoginMulti, FIL__, __LINE__, 0,
+#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
+			     MSG_UT_LG2X,
+#elif defined(HAVE_UTHOST)
+			     MSG_UT_LG2A,
+#else
+			     MSG_UT_LG2B,
+#endif
+			     user->name,
+			     user->ut_tty,
+#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
+			     user->ut_host,
+			     user->ut_ship,
+#elif defined(HAVE_UTHOST)
+			     user->ut_host,
+#endif
+			     ttt,
+			     status
+			     );
+	  }
+      
+      sh_utmp_login_morechecks(ut);
+      SL_RET0(_("sh_utmp_addlogin"));
+    }
+
+
+  /* ---------  LOGOUT ---------------- */
+  else if (ut->ut_name[0] == '\0'
+	   || ut->ut_type == DEAD_PROCESS  /* solaris does not clear ut_name */
+	   )
+    {
+      if (user != NULL)
+	{
+	  status = sh_utmp_login_r(user->name);
+	  /* sl_strlcpy(ttt, sh_unix_time (user->time), TIM_MAX); */
+	  (void) sl_strlcpy(ttt, sh_unix_time (ut->ut_time), TIM_MAX);
+	  sh_error_handle( ShUtmpLogout, FIL__, __LINE__, 0,
+#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
+			   MSG_UT_LG3X,
+#elif defined(HAVE_UTHOST)
+			   MSG_UT_LG3A,
+#else
+			   MSG_UT_LG3B,
+#endif
+			   user->name,
+			   user->ut_tty,
+#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
+			   user->ut_host,
+			   user->ut_ship,
+#elif defined(HAVE_UTHOST)
+			   user->ut_host,
+#endif
+			   ttt,
+			   status
+			   );
+	  userold->next = user->next;
+	  if (user == userlist)
+	    userlist = user->next;
+	  sh_utmp_logout_morechecks(user);
+	  SH_FREE(user);
+	  user = NULL;
 	}
       else
 	{
-	  userold = user;
-	  user    = user->next;
+	  (void) sl_strlcpy(terminated_line, ut->ut_line, UT_HOSTSIZE);
+	  (void) sl_strlcpy(ttt, sh_unix_time (ut->ut_time), TIM_MAX);
+	  sh_error_handle( ShUtmpLogout, FIL__, __LINE__, 0,
+			   MSG_UT_LG3C,
+			   terminated_line,
+			   ttt, 0
+			   );
 	}
-    }
-  return;
-}
-
-/* These variables are not used anywhere. They only exist
- * to assign &userold, &user to them, which keeps gcc from
- * putting them into a register, and avoids the 'clobbered
- * by longjmp' warning. And no, 'volatile' proved insufficient.
- */
-void * sh_dummy_850_userold = NULL;
-void * sh_dummy_851_user    = NULL;
-
-
-static void sh_utmp_checklogin (struct SH_UTMP_S * ut, time_t start_read)
-{
-  struct log_user   * user     = userlist;
-  struct log_user   * userold  = userlist;
-
-  struct log_user   * username = userlist;
-  volatile int    status;
-
-
-  SL_ENTER(_("sh_utmp_checklogin"));
-
-  if (ut->ut_line[0] == '\0')
-    SL_RET0(_("sh_utmp_checklogin"));
-
-  /* Take the address to keep gcc from putting them into registers. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_850_userold = (void*) &userold;
-  sh_dummy_851_user    = (void*) &user;
-
-  /* ------- find user -------- 
-   */
-  while (user != NULL) 
-    {
-      if (0 == sl_strncmp(user->ut_tty, ut->ut_line, UT_LINESIZE) &&
-	  0 == sl_strncmp(user->name, ut->ut_name, UT_NAMESIZE)) 
-	break;
-      userold = user;
-      user = user->next;
-    }
-
-
-  while (username != NULL) 
-    {
-      if (0 == sl_strncmp(username->name, ut->ut_name, UT_NAMESIZE) ) 
-	break;
-      username = username->next;
-    }
-
-  
-  if (user == NULL)
+      SL_RET0(_("sh_utmp_addlogin"));
+    }
+
+  /* default */
+  SL_RET0(_("sh_utmp_addlogin"));
+
+  /* #ifdef HAVE_UTTYPE                   */
+#else
+
+  if (user == NULL)   /* probably a login */
     {
       user = SH_ALLOC(sizeof(struct log_user));
+      sl_strlcpy(user->ut_tty,  ut->ut_line, UT_LINESIZE+1);
+      sl_strlcpy(user->name,    ut->ut_name, UT_NAMESIZE+1);
+#ifdef HAVE_UTHOST
+      sl_strlcpy(user->ut_host, ut->ut_host, UT_HOSTSIZE+1);
+#endif
+#ifdef HAVE_UTADDR
+      sl_strlcpy(user->ut_ship,my_inet_ntoa((struct in_addr)ut->ut_addr),16);
+#endif
+      user->time       = ut->ut_time;
       user->next       = userlist;
-      userlist         = (struct log_user *) user;
-    }
-  else if ( (user->time == ut->ut_time) &&
-	    0 == sl_strcmp (user->name, ut->ut_name))
-    {
-      /* we have it on record and nothing has changed */
-      user->last_checked = start_read;
-      goto out;
-    }
-  else
-    {
-      /* we have it on record and something has changed */
-      if (0 == sh_utmp_is_virtual(user->ut_tty, user->ut_host))
-	{
-	  /* reference count down on list of logged in users */
-	  status = sh_utmp_login_r(user->name);
-	  
-	  sh_utmp_log_out(ShUtmpLogout, user, status);
-	  sh_utmp_logout_morechecks((struct log_user *)user);
-	}
-    }
-
-  user->last_checked = start_read;
-  
-  (void) sl_strlcpy(user->ut_tty,  ut->ut_line, UT_LINESIZE+1);
-  (void) sl_strlcpy(user->name,    ut->ut_name, UT_NAMESIZE+1);
-#ifdef HAVE_UTHOST
-  (void) sl_strlcpy(user->ut_host, ut->ut_host, UT_HOSTSIZE+1);
-#else
-  user->ut_host[0] = '\0';
-#endif
-#ifdef HAVE_UTADDR
-#ifdef HAVE_UTADDR_V6
-  my_inet_ntoa(ut->ut_addr_v6, user->ut_ship, SH_IP_BUF);
-#else
-  my_inet_ntoa(ut->ut_addr, user->ut_ship, SH_IP_BUF);
-#endif
-#endif
-  user->time = ut->ut_time;
-  
-  if (username == NULL)        /* not yet logged in */
-    {
-      /* add this username to the list of logged in users */
-      status = sh_utmp_login_a(user->name);
-      
-      sh_utmp_log_one(ShUtmpLoginSolo, user, status);
-      
-    }
-  else if (0 == sh_utmp_is_virtual(user->ut_tty, (char*)user->ut_host))
-    {
-      /* add this username to the list of logged in users */
-      status = sh_utmp_login_a((char*)user->name);
-      
-      sh_utmp_log_multi(ShUtmpLoginMulti, user, status);
-    }
-  sh_utmp_login_morechecks(ut);
-  goto out;
-
-
- out:
-  sh_dummy_851_user    = NULL;
-  sh_dummy_850_userold = NULL;
-
-  SL_RET0(_("sh_utmp_checklogin"));
+      userlist         = user;
+
+      sl_strlcpy(ttt, sh_unix_time (user->time), TIM_MAX);
+
+
+      sh_error_handle( ShUtmpLoginSolo, FIL__, __LINE__, 0,
+#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
+		       MSG_UT_LG1X,
+#elif defined(HAVE_UTHOST)
+		       MSG_UT_LG1A,
+#else
+		       MSG_UT_LG1B,
+#endif
+		       user->name,
+		       user->ut_tty,
+#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
+		       user->ut_host,
+		       user->ut_ship,
+#elif defined(HAVE_UTHOST)
+		       user->ut_host,
+#endif
+		       ttt,
+		       1
+		       );
+      sh_utmp_login_morechecks(ut);
+    }
+  else  /* probably a logout */
+    {
+      sl_strlcpy(ttt, sh_unix_time (ut->ut_time), TIM_MAX);
+      /* sl_strlcpy(ttt, sh_unix_time (user->time), TIM_MAX); */
+
+      sh_error_handle( ShUtmpLogout, FIL__, __LINE__, 0,
+#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
+		       MSG_UT_LG2X,
+#elif defined(HAVE_UTHOST)
+		       MSG_UT_LG2A,
+#else
+		       MSG_UT_LG2B,
+#endif
+		       user->name,
+		       user->ut_tty,
+#if defined(HAVE_UTHOST) && defined(HAVE_UTADDR)
+		       user->ut_host,
+		       user->ut_ship,
+#elif defined(HAVE_UTHOST)
+		       user->ut_host,
+#endif
+		       ttt,
+		       1
+		       );
+      sh_utmp_logout_morechecks(user);
+      userold->next = user->next;
+      if (user == userlist)       /* inserted Apr 4, 2004 */
+	userlist = user->next;
+      SH_FREE(user);
+      user = NULL;
+    }
+
+  SL_RET0(_("sh_utmp_addlogin"));
+#endif
 }
 
 static time_t        lastmod  = 0;
-
-static void sh_utmp_check_internal ()
+static off_t         lastsize = 0;
+static unsigned long lastread = 0;
+
+static char * mode_path[] = { _PATH_WTMP, _PATH_WTMP, _PATH_UTMP };
+
+static void sh_utmp_check_internal (int mode)
 {
   struct stat   buf;
   int           error;
   struct SH_UTMP_S * ut;
-  int           val_retry;
-  time_t        start_read;
+  unsigned long this_read = 0;
 
   SL_ENTER(_("sh_utmp_check_internal"));
@@ -1028,34 +996,60 @@
   /* error if no access
    */
-  do {
-    val_retry = /*@-unrecog@*/lstat ( utmp_path, &buf)/*@+unrecog@*/;
-  } while (val_retry < 0 && errno == EINTR);
-
-  if (0 != val_retry) 
+  if (0 != retry_lstat(FIL__, __LINE__, mode_path[mode], &buf)) 
     {
       error = errno;
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle((-1), FIL__, __LINE__, error, MSG_E_ACCESS,
-		      (long) sh.real.uid, utmp_path);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
+		      (long) sh.real.uid, mode_path[mode]);
       SL_RET0(_("sh_utmp_check_internal"));
     }
 
-  /* check modification time
+  /* modification time
    */
-  if (/*@-usedef@*/buf.st_mtime <= lastmod/*@+usedef@*/)
+  if (mode < 2)
+    {
+      if (/*@-usedef@*/buf.st_mtime <= lastmod/*@+usedef@*/)
+	{ 
+	  SL_RET0(_("sh_utmp_check_internal"));
+	}
+      else
+	lastmod = buf.st_mtime;
+    }
+
+  /* file size
+   */
+  if (/*@-usedef@*/buf.st_size < lastsize/*@+usedef@*/ && mode < 2) 
     { 
-      SL_RET0(_("sh_utmp_check_internal"));
-    }
-  else
-    lastmod = buf.st_mtime;
-
-  sh_utmp_utmpname(utmp_path);
+      sh_error_handle((-1), FIL__, __LINE__, 0, MSG_UT_ROT,
+		      mode_path[mode]);
+      lastread = 0;
+#ifndef USE_SETUTENT
+      sh_utmp_feed_forward = 0L;
+#endif
+    }
+
+  if (mode < 2)
+    lastsize = buf.st_size;
+
+  if (buf.st_size == 0) 
+    SL_RET0(_("sh_utmp_check_internal"));
+
+  sh_utmp_utmpname(mode_path[mode]);
   sh_utmp_setutent();
+
+  /* 
+   * feed forward if initializing
+   * we need to do this here
+   */
+  if (mode < 2)
+    {
+      while (this_read < lastread) {
+	ut = sh_utmp_getutent();
+	++this_read;
+      }
+    }
 
   /* start reading
    */
-  start_read = time(NULL);
-  
+  this_read = 0;
   while (1 == 1) {
     ut = sh_utmp_getutent();
@@ -1063,24 +1057,38 @@
       break;
     /* modified: ut_user --> ut_name */
-    if (ut->ut_name[0] != '\0'
+    if (mode == 1 || (mode == 2 && ut->ut_name[0] != '\0'
 #ifdef HAVE_UTTYPE
-	&& ut->ut_type == USER_PROCESS
-#endif
-	)
-      sh_utmp_checklogin (ut, start_read);
+		      && ut->ut_type != DEAD_PROCESS
+#endif
+		      ))
+      sh_utmp_addlogin (ut);
+    /*************************************************
+    printf("%8s | %10s | %10s | %3d %5d | %16s | %ld\n", 
+	   ut->ut_name, ut->ut_id, ut->ut_line, 
+	   (int) ut->ut_type, (int) ut->ut_pid, 
+	   ut->ut_host, ut->ut_time);
+    ***************************************************/
+    ++this_read;
   }
 
   sh_utmp_endutent();
 
-  sh_utmp_purge_old (start_read);
+  if (mode < 2)
+    {
+      lastread += this_read;
+#ifndef USE_SETUTENT
+      sh_utmp_feed_forward += (long) (this_read * sizeof(struct SH_UTMP_S));
+      lastread = 0;
+#endif
+    }
 
   SL_RET0(_("sh_utmp_check_internal"));
 }
 
-extern void sh_ltrack_check(struct SH_UTMP_S * ut);
 
 static void sh_utmp_login_morechecks(struct SH_UTMP_S * ut)
 {
-  sh_ltrack_check(ut);
+  if (ut)
+    return;
   return;
 }
@@ -1088,5 +1096,6 @@
 static void sh_utmp_logout_morechecks(struct log_user * user)
 {
-  (void) user;
+  if (user)
+    return;
   return;
 }
